TalentSwitch = {}

local total = 0
local toFlash = {}

local function OnEvent(self, event, ...)
	self:UnregisterEvent("PLAYER_REGEN_ENABLED")
	if InCombatLockdown() then --you never know !
		self:RegisterEvent("PLAYER_REGEN_ENABLED")
		return
	end

	TalentSwitch.doBars()

	local talents = {}
	local active = {}	

	for i = 1, 6 do
		talents[i] = {}
	end


	for i = 1, MAX_NUM_TALENTS do
		local name, iconTexture, tier, column, selected, available = GetTalentInfo(i)

		if tier ~= nil and tier < 7 and tier > 0 then
			table.insert(talents[tier], name)
		else
			print(GetTalentInfo(i))
		end

		if selected then
			active[tier] = name
		end
	end



	local general, character = GetNumMacros()
	character = character + 36
	
	for j = 1, general do
		TalentSwitch.sub(j, talents, active)
	end

	for j = 37,  character do
		TalentSwitch.sub(j, talents, active)
	end

end

function TalentSwitch.sub(j, talents, active)

	local tiers = MAX_NUM_TALENTS / 3
	local name, tex, body, flag = GetMacroInfo(j)

	for i = 1, tiers do
		if active[i] ~= nil then
			
			for k = 1, 3 do
				
				if talents[i][k] == "Anti-Magic Zone" then
					body=body:gsub("Anti%-Magic Zone", active[i])
				else
					if active[i] == "Anti-Magic Zone" then
						body=body:gsub(talents[i][k], "Anti%-Magic Zone")
					else
						body=body:gsub(talents[i][k], active[i])
					end
				end
			end
		end
	end
	
	if string.len(body) < 256 then
		EditMacro(j, nil, nil, body)
	else
		print("TalentSwitch - ERROR: could not update macro "..name.." due to length constraints. ("..string.len(body).."/255)")
	end
		

end

function TalentSwitch.doBars()

	local talents = {}
	for i = 1, 6 do
		talents[i] = {}
	end
	local active = {}


	for i = 1, MAX_NUM_TALENTS do
		local name, iconTexture, tier, column, selected, available = GetTalentInfo(i)

		if name then
			if selected then
				local spellLink = GetSpellLink(name)
		
				if spellLink then 
					local spellID = spellLink:match("spell:(%d+)")
					active[tier] = spellID
				end
	
			else
				table.insert(talents[tier], name)
			end
		end
	end
	

	for i = 1, 120 do
		local type, id, subtype = GetActionInfo(i)
		local name = GetSpellInfo(id)

		if type == "spell" then
			for j = 1, 6 do

				if ( active[j] ~= nil and (name == talents[j][1] or name == talents[j][2]) ) then

					local passive = IsPassiveSpell(active[j])
					
					if passive == nil then
						PickupAction(i)
						ClearCursor()
						PickupSpell(active[j])
						PlaceAction(i)

						name2 = GetSpellInfo(active[j])
						toFlash[j] = active[j]

						print("Replaced "..name.." with "..name2.." on button "..i..".")
					else
						toFlash[j] = nil
						print("Passive talent selected, left "..name.." on button "..i..".")
					end
					break										-- no need to check further tiers if we match
				end
			end
		end
	end

	ClearCursor()
--	print("Flashing")
--	TalentSwitch.doFlash()

end

local frame = CreateFrame("Frame")
frame:SetScript("OnEvent", OnEvent)
frame:RegisterEvent("PLAYER_TALENT_UPDATE")
frame:RegisterEvent("PLAYER_LOGIN")
